/*
 *  @version 	        @(#)NCL.java	1.7 98/07/30
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package jfc;

import jfc.utils.*;

import suntest.javastar.lib.JSNonComponentLocator;
import suntest.javastar.lib.JSNCLData;
import com.sun.java.swing.*;
import com.sun.java.swing.table.JTableHeader;
import java.awt.Component;
import java.awt.Point;
import java.awt.AWTEvent;
import java.awt.event.MouseEvent;

/**	
 *  Non-component locator for JFC Swing
 *
 *  @date created      Oct 31, 1997
 *  @author	        Mark Hefner
 *
 */

public class NCL implements JSNonComponentLocator {

  public JSNCLData findObject(Component c, AWTEvent e){
    if(c instanceof JComponent){
      if(e instanceof MouseEvent){
	int x = ((MouseEvent)e).getX();
	int y = ((MouseEvent)e).getY();
	Point p = ((MouseEvent)e).getPoint();
	if(c instanceof JTabbedPane){
	  return TabbedLoc.findObject((JTabbedPane)c,x,y);
	} else if(c instanceof JTree){
	  return Tree.findObject((JTree)c,x,y);
	} else if(c instanceof JList){
	  return ListLoc.findObject((JList)c,p);
	} else if(c instanceof JTable){
	  return TableLoc.findObject((JTable)c,p);
	} else if(c instanceof JTableHeader){
	  return TableHeadLoc.findObject((JTableHeader)c,p);
	}
      }
    }
    return null;
  }
	
  public JSNCLData getNamedObjectData(Component c, String wname){
    if(c instanceof JComponent){
      if(c instanceof JTable){
	return TableLoc.getNamedObjectData((JTable)c,wname);
      }
      Parser P = new Parser(wname);
      if(P.Valid){
	if(c instanceof JTabbedPane){
	  return TabbedLoc.getNamedObjectData((JTabbedPane)c,P);
	} else if(c instanceof JTree){
	  return Tree.getNamedObjectData((JTree)c,P);
	} else if(c instanceof JList){
	  return ListLoc.getNamedObjectData((JList)c,P);
	} else if(c instanceof JTableHeader){
	  return TableHeadLoc.getNamedObjectData((JTableHeader)c,P);
	}
      }
    }
    return null;
  }
	

}
