/* ***************************************************
 * @(#)CafeNcl.java	1.3 98/06/22
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.cafe;

import suntest.javastar.lib.*;
import symantec.itools.awt.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import locators.cafe.utils.*;

/*
 * Non-Component locator for Symantec Visual Cafe
*/
public class CafeNcl implements JSNonComponentLocator {

  public JSNCLData findObject(Component c, AWTEvent e){
    if (e instanceof MouseEvent) {
      if (c instanceof ImageListBox)
        return ImageListLoc.findObject((ImageListBox)c, (MouseEvent)e);

      if (c instanceof TabPanel)
        return TabPanelLoc.findObject((TabPanel)c, (MouseEvent)e);

      if (c instanceof MultiList)
        return MultiListLoc.findObject((MultiList)c, (MouseEvent)e);

      if (c instanceof TreeView)
        return TreeViewLoc.findObject((TreeView)c, (MouseEvent)e);
    }
    return null;
  }
	
  public JSNCLData getNamedObjectData(Component c, String name){
    if(c instanceof ImageListBox)
      return ImageListLoc.getNamedObjectData((ImageListBox)c, name);

    if(c instanceof TabPanel)
      return TabPanelLoc.getNamedObjectData((TabPanel)c, name);

    if(c instanceof TreeView)
      return TreeViewLoc.getNamedObjectData((TreeView)c, name);

    if(c instanceof MultiList)
      return MultiListLoc.getNamedObjectData((MultiList)c, name);

    return null;
  }
}
