/* ***************************************************
 * @(#)CafeTm.java	1.7 98/06/19
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.cafe;

import suntest.javastar.lib.*;
import symantec.itools.awt.*;
import java.awt.Component;
import java.net.URL;

/*
 * Text mapping class for Symantec Visual Cafe
 */
public class CafeTm implements JSTextMapping {
  public String computeText(Component c){
    if(c instanceof Label3D)
      return ((Label3D)c).getText();
    if(c instanceof WrappingLabel)
      return ((WrappingLabel)c).getText();

    if(c instanceof RollOverButton)
      return ((RollOverButton)c).getActionCommand();
    if(c instanceof InvisibleButton)
      return ((InvisibleButton)c).getActionCommand();

    if(c instanceof ButtonBase){
      if(c instanceof LabelButton)
        return ((LabelButton)c).getText();

      if (c instanceof DirectionButton) {
        switch(((DirectionButton)c).getDirection()) {
          case DirectionButton.LEFT:
            return "LEFT";
          case DirectionButton.RIGHT:
            return "RIGHT";
          case DirectionButton.UP:
            return "UP";
          case DirectionButton.DOWN:
            return "DOWN";
          default:
            break;
        }
      } else if (c instanceof ImageHTMLLink) {
        URL l = ((ImageHTMLLink)c).getLinkURL();
        if (l != null) return l.toString();
      }
      return ((ButtonBase)c).getActionCommand();
    }

    if(c instanceof ImagePanel){
      URL l = ((ImagePanel)c).getImageURL();
      if (l != null)
        return l.toString();
      else
        return null;
    }

    return null;
  }

}
