/* ***************************************************
 * @(#)ImageList.java	1.2 98/06/18
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.cafe.utils;

import suntest.javastar.lib.*;
import symantec.itools.awt.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import locators.utils.Parser;

/*
 * Non-Component locator for Symantec Visual Cafe's ImageList
 */
public class ImageList {

  public static JSNCLData findObject(ImageListBox box, AWTEvent e){
    if(e instanceof MouseEvent){
      MouseEvent me = (MouseEvent)e;
      int idx = Peek.mouseCalcIndex(box, me.getY());
      if (idx >= 0)
        return new JSNCLData(idx + ":" + box.getText(idx), me.getPoint(), box.getText(idx));
    }
    return null;
  }
  public static JSNCLData getNamedObjectData(ImageListBox box, String name){
    Parser P = new Parser(name);
    if(P.Valid){
      int idx = P.Index;
      String rname = P.Value;
      if(idx >-1){
        if (Peek.validIndex(box, idx)) {
          if (rname == null)
            return listData(box, idx);
          else {
            if (box.getText(idx).equals(rname))
              return listData(box, idx);
            else
              return null;		
          }
        } else
          return null;
      } else {
        String[] list = box.getListItems();
        for(int i=0; i < box.countItems(); i++) {
          if (list[i].equals(rname) && Peek.validIndex(box, i))
            return listData(box, i);
        }
      }
    }
    return null;
  }

  static JSNCLData listData(ImageListBox box, int idx) {
    int y = 0;
    int max = box.getSize().height;
    while(y <= max) {
      if (idx == Peek.mouseCalcIndex(box, y)) break;
      y = y + 5;
    }
    if (y > max)
      return null;
    else
      return new JSNCLData(idx + ":" + box.getText(idx), new Point(0, y), box.getText(idx));	
  }
}
