/* ***************************************************
 * @(#)ImageListLoc.java	1.3 98/06/19
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.cafe.utils;

import suntest.javastar.lib.*;
import symantec.itools.awt.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import locators.utils.Parser;

/*
 * Non-Component locator for Symantec Visual Cafe's ImageList
 */
public class ImageListLoc {

  public static JSNCLData findObject(ImageListBox box, MouseEvent me){
    int idx = CafeSpy.mouseCalcIndex(box, me.getY());
    if (idx >= 0)
      return listData(box, idx);

    return null;
  }

  public static JSNCLData getNamedObjectData(ImageListBox box, String name){
    Parser P = new Parser(name);
    if(P.Valid){
      int idx = P.Index;
      String rname = P.Value;
      String[] list = box.getListItems();
      int length = list.length;
      if(idx > -1){
        if (idx < length && (rname == null || list[idx].equals(rname)))
          return listData(box, idx);
      } else {
        for(int i=0; i < length; i++) {
          if (list[i].equals(rname))
            return listData(box, i);
        }
      }
    }
    return null;
  }

  static JSNCLData listData(ImageListBox box, int idx) {
    int y = 0;
    int max = box.getSize().height;
    while(y <= max) {
      if (idx == CafeSpy.mouseCalcIndex(box, y)) break;
      y = y + 5;
    }
    if (y > max)
      return null;
    else
      return new JSNCLData(idx + ":" + box.getText(idx), new Point(0, y), box.getText(idx));	
  }
}
