/*
 *  @version 	        @(#)MultiListLoc.java	1.1 98/06/19
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.cafe.utils;

import suntest.javastar.lib.*;
import symantec.itools.awt.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import locators.utils.Parser;

/**	
 *
 *
 * @version 	      @(#)MultiListLoc.java	1.1 98/06/19
 * @author            Roongko Doong
 *
 */
public class MultiListLoc {

  public static JSNCLData findObject(MultiList ml, MouseEvent me){
    int x = me.getX();
    int y = me.getY();

    if (y < CafeSpy.headingHeight(ml)) { // It's in the heading
      return headingData(ml, CafeSpy.columnClicked(ml, x));
    }

      // cells
    return cellData(ml, CafeSpy.rowClicked(ml, y), CafeSpy.columnClicked(ml, x));
  }

  public static JSNCLData getNamedObjectData(MultiList ml, String name){
    if (name.indexOf(headLabel) == 0) { // It's in heading
      Parser P = new Parser(name.substring(headLabel.length()));
      if(P.Valid){
        int idx = P.Index;
        String rname = P.Value;
        String[] list = ml.getHeadings();
        int length = list.length;
        if(idx > -1){
          if (idx < length && rname.equals(list[idx]))
            return headingData(ml, idx);
        } else {
          for(int i = 0; i < length; i++) {
            if (list[i].equals(rname))
              return headingData(ml, i);
          }
        }
      }
    } else { // It's in cells
      int ci = name.indexOf(',');
      if(ci>0){
        try {
          int r = Integer.parseInt(name.substring(0,ci));
          int c = Integer.parseInt(name.substring(1+ci));
          return cellData(ml, r, c);
        } catch (Exception e) {}
      }
    }

    return null;
  }

  private static JSNCLData headingData(MultiList ml, int idx) {
    return new JSNCLData(headLabel + idx + ":" + ml.getHeading(idx),
                         new Point(CafeSpy.columnCorner(ml, idx), 1),
                         ml.getHeading(idx));
  }

  private static JSNCLData cellData(MultiList ml, int row, int col) {
    return new JSNCLData("" + row + "," + col, new Point(CafeSpy.columnCorner(ml, col), CafeSpy.rowCorner(ml, row)), ml.getCellText(row, col));
  }

  private final static String headLabel = "HEADING#";
}
