/*
 *  @version 	        @(#)TabPanelLoc.java	1.3 98/06/19
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.cafe.utils;

import suntest.javastar.lib.*;
import symantec.itools.awt.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import locators.utils.Parser;

/**	
 *
 *
 * @version 	      @(#)TabPanelLoc.java	1.3 98/06/19
 * @author            Roongko Doong
 *
 */
public class TabPanelLoc {

  public static JSNCLData findObject(TabPanel t, MouseEvent e){
    int idx = CafeSpy.whichTab(t, e.getX(), e.getY());
    return tabData(t, idx, CafeSpy.whichTabPoly(t, idx));
  }

  public static JSNCLData getNamedObjectData(TabPanel t, String wname){
    Parser P = new Parser(wname);
    if(P.Valid){
      int idx = P.Index;
      String rname = P.Value;
      if(idx > -1) {
        if (idx < t.countTabs() &&
            (rname == null || t.getPanelLabel(idx).equals(rname)))
          return tabData(t, idx, CafeSpy.whichTabPoly(t, idx));
      } else {
        String[] list = t.getPanelLabels();
        for(int i=0; i < list.length; i++) {
          if (list[i].equals(rname))
            return tabData(t, i, CafeSpy.whichTabPoly(t, idx));
        }
      }
    }
    return null;
  }

  static JSNCLData tabData(TabPanel t, int idx, Point p) {
    return new JSNCLData(idx + ":" + t.getLabel(idx), p, t.getLabel(idx));
  }
}
