/*
 *  @version 	        @(#)TreeViewLoc.java	1.1 98/06/19
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.cafe.utils;

import suntest.javastar.lib.*;
import symantec.itools.awt.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import locators.utils.Parser;

/**	
 *
 *
 * @version 	      @(#)TreeViewLoc.java	1.1 98/06/19
 * @author            Roongko Doong
 *
 */
public class TreeViewLoc {

  public static JSNCLData findObject(TreeView tree, MouseEvent me){
    return nodeData(tree, CafeSpy.nodeClicked(tree, me.getY()));
  }

  public static JSNCLData getNamedObjectData(TreeView tree, String name){
    Parser P = new Parser(name);
    if(P.Valid) {
      int idx = P.Index;
      String rname = P.Value;
      String[] list = tree.getTreeStructure();
      int length = list.length;
      if(idx > -1){
        if (idx < length && deletePreSpace(list[idx]).equals(rname))
          return nodeData(tree, idx);
      } else {
        for(int i=0; i < length; i++) {
          if (deletePreSpace(list[i]).equals(rname))
            return nodeData(tree, i);
        }
      }
    }
    return null;
  }

  private static JSNCLData nodeData(TreeView tree, int idx) {
    return new JSNCLData(idx + ":" + deletePreSpace(tree.getTreeStructure()[idx]), CafeSpy.nodeCorner(tree, idx), CafeSpy.getTreeNode(tree, idx));
  }

  private static String deletePreSpace(String s) {
		if(s != null && s.length() > 0)	{
      int length;
      length = s.length();

      if(s.charAt(0) != ' ' && s.charAt(0) != '\t')
        return s;

      int i = 1;
      for(; i < length; i++) {
        if(s.charAt(i) != ' ' && s.charAt(i) != '\t')
          break;
      }
      return s.substring(i);
    }
    return null;
	}

}
