/* ______________________________________________________________________
 * Copyright (c) 1998, KL GROUP INC.  All Rights Reserved.
 * http://www.klg.com
 *
 * This software is the confidential and proprietary information of KL
 * Group, Inc. ("Confidential Information").  You shall not disclose such
 * Confidential Information and shall use it only in accordance with the
 * terms of the license agreement you entered into with KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. KL GROUP SHALL NOT BE LIABLE FOR ANY
 * DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * ______________________________________________________________________
 */

package locators.klgroup;

import suntest.javastar.lib.*;
import java.awt.*;
import java.awt.event.*;
import jclass.table3.*;

/*
 * Non Component Locator for KL Group JClass Table3.
 * In Javastar record mode, this locator allows identification
 * of the particular cell that is being clicked. In playback mode,
 * it will translate a particular cell coordinate into the appropriate
 * pixel coordinates.
 *
 */
public class KlgTable3 implements JSNonComponentLocator {

public JSNCLData findObject(Component c, AWTEvent ev) {
    Class clip = null;
    try {
        clip = Class.forName("jclass.table3.Clip");
    } catch(ClassNotFoundException excpt){excpt.printStackTrace();}
    if (clip.isInstance(c) && ev instanceof MouseEvent) {
        Table tb = (Table)c.getParent();
        MouseEvent me = (MouseEvent)ev;
        int x = me.getX();
        int y = me.getY();
        Event nev =
            new Event(ev.getSource(), me.getWhen(), ev.getID(), x, y, 0,
                  (me.getModifiers() & ~InputEvent.BUTTON1_MASK));
        JCCellPosition pos = tb.XYToCell(nev.x, nev.y);
        if (pos != null)
            return tableData(tb, pos.row, pos.column);
    }
    return null;
}

public JSNCLData getNamedObjectData(Component c, String name) {
    Class clip = null;
    try {
        clip = Class.forName("jclass.table3.Clip");
    } catch(ClassNotFoundException excpt){excpt.printStackTrace();}
    if (clip.isInstance(c)) {
        int ci = name.indexOf(',');
        if(ci>0){
            try{
                int row = Integer.parseInt(name.substring(0,ci));
                int column = Integer.parseInt(name.substring(1+ci));
                return tableData((Table)c.getParent(), row, column);
            } catch(Exception e){       }
        }
    }
    return null;
}

static JSNCLData tableData(Table tb, int row, int col) {
    Rectangle rec = new Rectangle();
    if (tb.getBounds(row, col, rec)) {
      Object data = tb.getDataSource().
          getTableDataItem(row, col);
      if (data == null) {
        data = tb.getComponent(row, col);
      }
      return new JSNCLData(row + "," + col, new Point(rec.x, rec.y), data);
    }
    else
      return null;
}

}
