/*
 *  @version 	        @(#)KlgTm.java	1.6 98/05/15
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.klgroup;

import suntest.javastar.lib.*;
import java.awt.*;
import java.awt.event.*;
import jclass.bwt.*;

/*
 * Text mapping class for KL Group JClass toolkit
*/
public class KlgTm implements JSTextMapping  {

  public String computeText(Component c){
    if(c instanceof jclass.bwt.JCLabel){
      if (c instanceof jclass.bwt.JCArrowButton) {
	switch (((jclass.bwt.JCArrowButton)c).getOrientation()) {
	case JCArrowButton.LEFT:
	  return "LEFT";
	case JCArrowButton.RIGHT:
	  return "RIGHT";
	case JCArrowButton.UP:
	  return "UP";
	case JCArrowButton.DOWN:
	  return "DOWN";
	default:
	  break;
	}
      }
      if (c instanceof jclass.bwt.JCButton) {
	String text = ((jclass.bwt.JCButton)c).getText();
	if (text != null && text.length() > 0)
	  return text;
	else
	  return ((jclass.bwt.JCButton)c).getActionCommand();
      }
      return ((jclass.bwt.JCLabel)c).getText();
    }
    return null;
  }
}
