/*
 *  @version 	        @(#)klgroup.java	1.5 98/05/15
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.klgroup;

import suntest.javastar.lib.*;
import java.awt.*;
import jclass.bwt.*;
import locators.klgroup.utils.*;

/*
 * Non Component Locator for KL Group JClass toolkit
 * Only covers JCMultiColumnListComponent and
 * JCOutlinerComponent (and those only weakly)
 */
public class klgroup implements JSNonComponentLocator {

  public JSNCLData findObject(Component c,AWTEvent ev) {


    if (c instanceof JCMultiColumnListComponent) {
      MultiColumnLocator mc = new MultiColumnLocator();
      return mc.findObject (c, ev);
    } else if (c instanceof JCOutlinerComponent ) {
      JCOutlinerLocator jc = new JCOutlinerLocator ();
      return jc.findObject (c, ev);
    } else if (c instanceof JCListComponent ) {
      ListComponent jc = new ListComponent();
      return jc.findObject (c, ev);
    }
    return null;
  }

  public JSNCLData getNamedObjectData(Component c,String name) {

    if (c instanceof JCMultiColumnListComponent) {
      MultiColumnLocator mc = new MultiColumnLocator();
      return mc.getNamedObjectData (c, name);
    } else if (c instanceof JCOutlinerComponent) {
      JCOutlinerLocator jc = new JCOutlinerLocator ();
      return jc.getNamedObjectData(c, name);
    } else if (c instanceof JCListComponent ) {
      ListComponent jc = new ListComponent();
      return jc.getNamedObjectData(c, name);
    }
    return null;
  }
}
