/*
 *  @version 	        @(#)newKLG.java	1.6 98/05/15
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.klgroup;

import suntest.javastar.lib.*;
import java.awt.*;
import java.awt.event.*;
import jclass.bwt.*;
import locators.klgroup.utils.*;

/*
 * Non Component Locator for KL Group JClass toolkit*
 */
public class newKLG  implements JSNonComponentLocator {

  public JSNCLData findObject(Component c, AWTEvent ev) {
    if(ev instanceof MouseEvent){
      MouseEvent me = (MouseEvent)ev;
      int x = me.getX();
      int y = me.getY();
      Event nev =
	new Event(ev.getSource(), me.getWhen(), ev.getID(), x, y, 0,
		  (me.getModifiers() & ~InputEvent.BUTTON1_MASK));
      if (c instanceof JCMultiColumnListComponent) {
	return newMCL.findObject ((JCMultiColumnListComponent)c, nev, x, y);
      } else if (c instanceof JCOutlinerComponent ) {
	return newOutliner.findObject ((JCOutlinerComponent)c, nev);
      } else if (c instanceof JCListComponent ) {
	return ListComponent.findObject ((JCListComponent)c, nev);
      }
    }
    return null;
  }

  public JSNCLData getNamedObjectData(Component c, String name) {
    if (c instanceof JCMultiColumnListComponent && name != null) {
      return newMCL.getNamedObjectData ((JCMultiColumnListComponent)c, name);
    } else if (c instanceof JCOutlinerComponent) {
      return newOutliner.getNamedObjectData((JCOutlinerComponent)c, name);
    } else if (c instanceof JCListComponent ) {
      return ListComponent.getNamedObjectData((JCListComponent)c, name);
    }

    return null;
  }
}
