/*
 *  @version 	        @(#)JCOutlinerLocator.java	1.4 98/05/15
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.klgroup.utils;

import suntest.javastar.lib.*;
import java.awt.*;
import java.awt.event.*;
import jclass.bwt.JCOutlinerComponent;
import jclass.bwt.JCOutlinerNode;
import jclass.bwt.JCOutlinerNodeStyle;
import jclass.util.JCVector;

/*
 * Non Component Locator for JCOutliner of KL Group JClass toolkit
 */
public class JCOutlinerLocator implements JSNonComponentLocator {

  public JSNCLData findObject(Component c, AWTEvent ev) {

	JCOutlinerComponent jz;
	if (c instanceof JCOutlinerComponent)
		jz = (JCOutlinerComponent)c;
	else
		return null;
		
    int x=((MouseEvent)ev).getX();
    int y=((MouseEvent)ev).getY();

	// create an old dummy event
	Event nev = new Event (c, Event.ACTION_EVENT, null);
	// add its x-y coordinates
	nev.x = ((MouseEvent)ev).getX();
	nev.y = ((MouseEvent)ev).getY();

	JCOutlinerNode jnode = null;
	jnode = jz.eventToNode (nev, false);
	// should the class be the outliner node or the parent class?
	if (c.getName() != null) {
       	return new JSNCLData(jnode.getLabelString()+","+nev.x,
			new Point(nev.x,nev.y), jz);
	}
	return null;
  }	

  public JSNCLData getNamedObjectData(Component c,String name) {
	  	
	JCOutlinerComponent jz;
	if (c instanceof JCOutlinerComponent)
		jz = (JCOutlinerComponent)c;
	else
		return null;

	int offsetx=0, offsety=0;

	offsetx = new Integer (name.substring(name.indexOf(",")+1)).intValue();

	// clobber it:
	name = name.substring(0, name.indexOf(","));

	// get the list of visible nodes:
	JCVector visiblenodes = jz.getVisibleNodes ();

	JCOutlinerNode jcnode = null;
	// add the spacing into it, and (horrifyingly) a magic amount:
	int stdincr = jz.getNodeHeight() + jz.getSpacing() + 2;
		
	// walk the list, compare the value
	for (int i=0;i<visiblenodes.size();i++) {

		jcnode = (JCOutlinerNode)visiblenodes.elementAt(i);
		// Okay, advance the offsets here/
		offsety += stdincr;

		if (jcnode.getLabelString().equals(name))
			break;
	}
    return new JSNCLData(name,new Point(offsetx,offsety),c);
  }
}
