/*
 *  @version 	        @(#)MultiColumnLocator.java	1.5 98/05/15
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.klgroup.utils;

import suntest.javastar.lib.*;
import java.awt.*;
import java.awt.event.*;
import jclass.bwt.*;

/*
 * Non Component Locator for JCMultiColumnList of KL Group JClass toolkit
 */
public class MultiColumnLocator implements JSNonComponentLocator {

  public JSNCLData findObject(Component c,AWTEvent ev) {
    if (c instanceof JCMultiColumnListComponent) {
      JCMultiColumnListComponent jc=(JCMultiColumnListComponent)c;
      int rowHeight;
      int x=((MouseEvent)ev).getX();
      int y=((MouseEvent)ev).getY();
      int offsetx=0,offsety=0;
      int column= 0;
      int row= 0;
      String name=null;
      while (x>jc.getColumnPosition(column))
	column++;
      offsetx=jc.getColumnPosition(column-1);
      while (y>jc.getBounds(row,true).y)
	row++;
      name=(column-1)+","+(row-1);
      offsety=jc.getBounds(row-1,true).y;
      return new JSNCLData(name,new Point(offsetx,offsety),c);
    }
    return null;
  }
  public JSNCLData getNamedObjectData(Component c,String name) {
    if (c instanceof JCMultiColumnListComponent) {
      JCMultiColumnListComponent jc=(JCMultiColumnListComponent)c;
      int column=0,row=0;
      if (name.indexOf(",")== -1)
	return null;
      try {
	column=new Integer(name.substring(0,name.indexOf(","))).intValue();
	row=new Integer(name.substring(name.indexOf(",")+1)).intValue();
      } catch (NumberFormatException e) {
	return null;
      }
      //      System.out.println("klinfo:"+column+" "+row);
      int offsetx=jc.getColumnPosition(column);
      int offsety=jc.getBounds(row,true).y;

      return new JSNCLData(name,new Point(offsetx,offsety),c);
    }
    return null;
  }
}
