/*
 *  @version 	        @(#)newMCL.java	1.5 98/05/15
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.klgroup.utils;

import suntest.javastar.lib.*;
import java.awt.*;
import java.awt.event.*;
import jclass.bwt.*;
import jclass.util.JCVector;
import locators.klgroup.utils.*;
import locators.utils.Parser;

/*
 * Non Component Locator for JCMultiColumnList of KL Group JClass toolkit
 */
public class newMCL implements JSNonComponentLocator {

  public JSNCLData findObject(Component c, AWTEvent ev) {
    if (c instanceof JCMultiColumnListComponent &&
	ev instanceof MouseEvent) {
      MouseEvent me = (MouseEvent)ev;
      Event nev =
	new Event(ev.getSource(), me.getWhen(), ev.getID(),
		  me.getX(), me.getY(), 0,
		  (me.getModifiers() & ~InputEvent.BUTTON1_MASK));
      return findObject ((JCMultiColumnListComponent)c, nev, me.getX(), me.getY());
    }
    return null;
  }

  public static JSNCLData findObject(JCMultiColumnListComponent jc, Event ev,
				     int x, int y) {
    int row = jc.eventToRow(ev, true);
    if (row == BWTEnum.NOTFOUND) return null;

    int column= 0;
    while (x >= jc.getColumnPosition(column + 1))
      column++;

    return MCLData(jc, row, column, new Point(jc.getColumnPosition(column), jc.getBounds(row, true).y));
  }

  public JSNCLData getNamedObjectData(Component c, String name) {
    if (c instanceof JCMultiColumnListComponent && name != null) {
      return getNamedObjectData((JCMultiColumnListComponent)c, name);
    }
    return null;
  }

  public static JSNCLData getNamedObjectData(JCMultiColumnListComponent jc, String name) {
    int ci = name.indexOf(',');
    if(ci>0){
      try{
	int row = Integer.parseInt(name.substring(0,ci));
	int column = Integer.parseInt(name.substring(1+ci));
	return MCLData(jc, row, column, new Point(jc.getColumnPosition(column), jc.getBounds(row, true).y));
      } catch(Exception e){	}
    }

    return null;
  }

  static JSNCLData MCLData(JCMultiColumnListComponent jc, int r, int c,
			   Point p) {
    Object data = null;
    Object o = jc.getItem(r);
    if (o instanceof JCVector) {
      JCVector v = (JCVector)o;
      if (c < v.size()) {
	data = v.elementAt(c);
      }
    }
    return new JSNCLData(r + "," + c, p, data);
  }
}
