/*
 *  @version 	        @(#)IFC_Info.java	1.2 98/05/15
 *
 * Copyright (c) 1997-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package locators.utils;


/**
** stores info about the IFC objects
*   used by buildTree and find methods to identify the tags
*   of the IFC components.
*/
public class IFC_Info  {
  /** the ifc object */
  public netscape.application.View view;
  /** the object's parent if top level null is parent */
  public String parent;
  /** if unique in application the tag name with caption */
  public String localTagName;
  /** the full tag with hierarchy */
  public String fullTagName;
  /** the caption of object if available */
  public String caption;
  /** the actual tag to use, calls setTheTag to determine how to set */
  public String theTag;
  /** the class name of the object without to package name */
  public String className;
  /** the index of the object relative to its parent */
  public int index;

  public IFC_Info(netscape.application.View v,String parent) {
    this(v,parent,"","","","","",-1);
  }

  public IFC_Info(netscape.application.View v,
		  String parent,
		  String localTagName,
		  String fullTagName,
		  String caption,
		  String theTag,
		  String className,
		  int index) {
    this.view=v;
    this.parent=parent;
    this.localTagName=localTagName;
    this.fullTagName=fullTagName;
    this.parent=parent;
    this.caption=caption;
    this.theTag=theTag;
    this.className=className;
    this.index=index;
  }
		
  /** sets theTag, if the local name is not null local name is used
   * otherwise the full tag name is used.
   */
  public void setTheTag() {
    if (localTagName!=null) {
      theTag=localTagName;
    } else
      theTag=fullTagName;
  }

  public String toString() {
    return "IFC_Info: view="+view+" tag="+theTag+" caption="+caption+" index="+index;
  }
}
