/* ****************************************************************
** @(#)namePop.java	1.2 0
**
** Copyright 1997 Sun Microsystems, Inc. All Rights Reserved
**
** ****************************************************************
*/

import java.awt.*;
import java.awt.event.*;
import gjt.*;

public class namePop extends Frame implements ActionListener {		

  public List nameList;
  public OpenlookButton viewBtn;
  public OpenlookButton exitBtn;
  private namedb parent;

  public void init() {
    setTitle(parent.strings.namePop());
    if (parent.UseSetName)
      setName("namePop");
    setBackground(Color.lightGray);
    
    Panel mpanel=new Panel();
    add(mpanel);

    GridBagLayout grid = new GridBagLayout();
    if (parent.UseSetName)
      this.setName("namePop");

    Label label=new Label(parent.strings.namePopl());
    if (parent.UseSetName)
      label.setName("namePop_nameLabel");
    label.setFont(new Font("Serif",Font.ITALIC,16));
    mpanel.add(label);

    nameList = new List(5);
    if (parent.UseSetName)
      nameList.setName("name_list");
    nameList.setBackground(Color.lightGray);
    nameList.setFont(new Font("Serif",Font.ITALIC,16));
    nameList.addActionListener(this);
    mpanel.add(nameList);

    Panel bpanel=new Panel();
    bpanel.setLayout(new GridLayout(1,2));
    Box box1=new Box(bpanel,"");
    mpanel.add(box1);
    
    viewBtn = new OpenlookButton();
    viewBtn.setLabel(parent.strings.namePopViewb());
    if (parent.UseSetName)
      viewBtn.setName("nameview_button");
    viewBtn.setFont(new Font("Serif",Font.ITALIC,16));
    viewBtn.addActionListener(this);
    bpanel.add(viewBtn,new Point(0,0));
    
    exitBtn = new OpenlookButton();
    exitBtn.setLabel(parent.strings.namePopCloseb());
    if (parent.UseSetName)
      exitBtn.setName("nameclose_button");
    exitBtn.setFont(new Font("Serif",Font.ITALIC,16));
    exitBtn.addActionListener(this);
    bpanel.add(exitBtn,new Point(0,1));

    constrain(grid,label,0,0,1,1,GridBagConstraints.WEST,GridBagConstraints.NONE,0,0,0,0,0,0,0,0);
    constrain(grid,nameList,0,1,4,3,GridBagConstraints.WEST,GridBagConstraints.NONE,0,0,0,0,0,0,0,0);
    constrain(grid,box1,0,5,1,1,GridBagConstraints.CENTER,GridBagConstraints.HORIZONTAL,0,0,0,0,0,0,0,0);
    
    mpanel.setLayout(grid);
    
    GridBagLayout maingrid=new GridBagLayout();
    constrain(maingrid,mpanel,0,0,1,1,GridBagConstraints.CENTER,GridBagConstraints.NONE,0,0,20,30,20,30,0,0);
    setLayout(maingrid);
  }

  public void actionPerformed(ActionEvent event) {
    Component comp=(Component)event.getSource();
    if (comp==exitBtn) {
      popCancel();
    }
    if (comp==viewBtn) {
	popOk();
    }
  }

  public void constrain(GridBagLayout grid,Component comp,int gridx,int gridy,int gridwidth,int gridheight,int anchor,int fill,int ipadx,int ipady,int top,int left,int bottom,int right,double weightx,double weighty) {
    GridBagConstraints con=new GridBagConstraints();
    con.gridx = gridx;
    con.gridy = gridy;
    con.gridwidth = gridwidth;
    con.gridheight = gridheight;
    con.anchor = anchor;
    con.fill = fill;
    con.ipadx = ipadx;
    con.ipady = ipady;
    con.weightx=weightx;
    con.weighty=weighty;
    con.insets = new Insets(top,left,bottom,right);
    grid.setConstraints(comp,con);
  }
  
  public void setParent(namedb caller) {
    parent = caller;
  }
  
  public void updateData() {
    int i=0;
    String listItems[]=parent.getApi().getAllKeys();
    nameList.clear();
    for (i=0;i<listItems.length;i++) {
      nameList.addItem(listItems[i]);
    }
  }
  public void showIt() {
    updateData();
    pack();
    show();
  }
  
  public void popCancel() {
    hide();
  }
  
  public void popOk() {
    if (nameList.getSelectedIndex() == -1) {
      return;
    }
    parent.getApi().showEntry(nameList.getSelectedIndex());
    parent.updateScreen();
  }
}


